﻿/*
 * Created by SharpDevelop.
 * User: Administrator
 * Date: 2006-12-16
 * Time: 9:37
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Net;
using System.IO;
using NChardet;

namespace Test
{
	class MainClass
	{
		public static bool found = false;
		public static void Main(string[] args)
		{
			if (args.Length != 1 && args.Length != 2)
			{
				Console.WriteLine("Usage: Test.exe <url> [<languageHint>]");
				Console.WriteLine("");
	  			Console.WriteLine("Where <url> is http://...");
	  			Console.WriteLine("For optional <languageHint>. Use following...");
	  			Console.WriteLine("    1 => Japanese");
	  			Console.WriteLine("    2 => Chinese");
	  			Console.WriteLine("    3 => Simplified Chinese");
	  			Console.WriteLine("    4 => Traditional Chinese");
	  			Console.WriteLine("    5 => Korean");
	  			Console.WriteLine("    6 => Dont know (default)");
	  			Console.ReadLine();
	  			return;
			}
			int lang = (args.Length == 2)? int.Parse(args[1]) : PSMDetector.ALL ;
			
			Detector det = new Detector(lang) ;
			MyCharsetDetectionObserver cdo = new MyCharsetDetectionObserver();
			det.Init(cdo);
			
			Uri url = new Uri(args[0]);
			//Uri url = new Uri("http://cn.yahoo.com/");
			HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
			HttpWebResponse response = (HttpWebResponse)request.GetResponse();
			Stream stream = response.GetResponseStream();
			
			byte[] buf = new byte[1024] ;
			int len;
			bool done = false ;
			bool isAscii = true ;
			
			while( (len=stream.Read(buf,0,buf.Length)) != 0) {
				// Check if the stream is only ascii.
				if (isAscii)
		    		isAscii = det.isAscii(buf,len);

				// DoIt if non-ascii and not done yet.
				if (!isAscii && !done)
 		    		done = det.DoIt(buf,len, false);
			}
			
			stream.Close();
			
			det.DataEnd();
			
			if (isAscii) {
	   			Console.WriteLine("CHARSET = ASCII");
	   			found = true ;
			}
			else if (cdo.Charset != null)
			{
				Console.WriteLine("CHARSET = {0}",cdo.Charset);
				found = true;
			}
			
			if (!found) {
				string[] prob = det.getProbableCharsets() ;
	   			for(int i=0; i<prob.Length; i++) {
					Console.WriteLine("Probable Charset = " + prob[i]);
				}
			}
			Console.ReadLine();
		}
	}	
	
}
